from dataEngine import Common


class AppConfig(Common.PbxDataObject):
    def __init__(self):
        self.port = 5039
        self.out_file = None
        self.isTest = False
        self.stop = False
        self.rewrite_out_file = False
        self.dump = None
        self.ami_events = None
        self.daemon = False
        self.mode = []
        self.compare_traces = False
        self.rewrite_traces = False
        self.show_events = False
        self.loglevel = None
        self.in_file = None
        self.ldap_file = None
        self.realtime = False
        self.cache_ldap = False
        self.full_debug = False
        self.stage = False

    def set(self, param, value):
        if value is not None:
            setattr(self, param, value)


APP_CONFIG = AppConfig()


def set(name, value):
    if name == "mode" and "auto" in value:
        if Common.XBEES_LICENSE == '1':
            value = ['calls', 'presence']
        else:
            value = ['none']
    APP_CONFIG.set(name, value)


def get(name):
    return APP_CONFIG.get(name)


def isTest():
    return APP_CONFIG.get("isTest")


def isDaemon():
    return APP_CONFIG.get("daemon")


def isStopped():
    return APP_CONFIG.get("stop")


def checkMode(event_type):
    return event_type in APP_CONFIG.get("mode")
