import json
import subprocess

# PBX
res, PBX_SERIAL = subprocess.getstatusoutput("serial")
if res != 0:
    PBX_SERIAL = "dummypbxserial"
try:
    PBX_KEY = subprocess.getoutput("sed '18q;d' /rw2/etc/sf2")
except FileNotFoundError:
    PBX_KEY = "dummypbxkey"

# x-bees license
try:
    XBEES_LICENSE = subprocess.getoutput("sed '21q;d' /rw2/etc/sf2")
except FileNotFoundError:
    XBEES_LICENSE = False


class PbxDataObject:
    __slots__ = ()
    def __getitem__(self, key):
        return getattr(self, key)

    def __setitem__(self, key, value):
        setattr(self, key, value)

    def get(self, param):
        return getattr(self, param, None)

    def set(self, param, value):
        if value:
            setattr(self, param, value)


class PbxDataEncoder(json.JSONEncoder):
    __slots__ = ()
    def default(self, obj):
        if isinstance(obj, PbxDataObject):
            return {(key[1:] if key[0] == "_" else key):(val if val else None) for key,val in obj.__dict__.items()}
        return json.JSONEncoder.default(self, obj)
