import subprocess
from threading import Thread
from dataEngine import AppConfig, Ami, Logger

logger = Logger.get()


def process_pcap():
    file = AppConfig.get("dump")
    port = str(Ami.get_my_port())
    logger.info("Start tcpdump {} on port: {}".format(file, port))
    DUMP_WRITER.proc = subprocess.Popen(["tcpdump", "-w", file, "-ilo", "port", port], stderr=subprocess.DEVNULL,
                                        stdout=subprocess.DEVNULL)
    DUMP_WRITER.proc.communicate()


def init():
    if AppConfig.get("dump"):
        DUMP_WRITER.thread.start()


def close():
    DUMP_WRITER.exit = True
    if DUMP_WRITER.proc:
        DUMP_WRITER.proc.kill()
    if DUMP_WRITER.thread.is_alive():
        DUMP_WRITER.thread.join()


class DumpWriter():
    def __init__(self):
        self.thread = Thread(target=process_pcap)
        self.exit = False
        self.proc = None


DUMP_WRITER = DumpWriter()
